using System;
using Microsoft.Office.Core;
using System.Reflection;
using System.Xml.Serialization;
using System.Runtime.Serialization;
using System.ComponentModel;
using System.Windows.Forms;
using DkmS.Office2003;
namespace DkmS_Hello {
	[LoadIn("Word")]
	[LoadIn("Excel")]
	[LoadIn("Outlook")]
	[PlugName("Hello, Any Programs")]
	[PlugDescr("Using plugin in some programs")]
	public class HelloAny : OfficePlugin{
		string Text="Sample Hello plugin";
		#region overrides
		public override void InitializePlugin(object App, CommandBarControl Menu) {
			base.InitializePlugin (App, Menu);
			if(App!=null)
				RestoreCfg();
			else
				SaveCfg();
		}
		public override void DoAction() {
			ShowMsg("We are in "+appName,Text,MsoButtonSetType.msoButtonSetOK,MsoIconType.msoIconTip);
		}
		#endregion
		#region Config
		HelloPluginConfig cfg=new HelloPluginConfig();

		void RestoreCfg() {
			try{
				this.cfg=(HelloPluginConfig)cfg.RestoreFrom(this.ConfigFileName);
			}catch{}
			try{
				if(cfg==null){
					cfg=new HelloPluginConfig();
					cfg.Caption=this.Menu_Item.Caption;
					cfg.Text=this.Text;
				}else{
					this.Text=cfg.Text;
					this.Menu_Item.Caption=cfg.Caption;
				}
			}catch(Exception err){
				ShowMsg(err.Message+"\n"+err.StackTrace,this.Name);
			}
		}
		void SaveCfg() {
			cfg.SaveTo(this.ConfigFileName);
		}
		public override object Config {
			get {
				return cfg;
			}
			set {
				if(value!=null){
					cfg=(HelloPluginConfig)value;
					if(cfg.Caption!=null & cfg.Caption!="")
						this.Menu_Item.Caption=cfg.Caption;
					else
						cfg.Caption=this.Menu_Item.Caption;
					if(cfg.Text!=null & cfg.Text!="")
						this.Text=cfg.Text;
					else
						cfg.Text=this.Text;
					SaveCfg();
				}
			}
		}
		#endregion
	}

	public class HelloPluginConfig : Config{
		string caption="";
		[XmlAttribute("caption")]
		[Description("Text of plugin label in menu")]
		public string Caption{
			get{return caption;} set{caption=value;}
		}
		string text="";
		[XmlAttribute("text")]
		[Description("Text in balloon")]
		public string Text{get{return text;} set{text=value;}}
	}
}
